首页 > 代码库 > HDU-4035 Maze
HDU-4035 Maze
http://acm.hdu.edu.cn/showproblem.php?pid=4035
树上的概率dp。
MazeTime Limit: 2000/1000 MS (Java/Others) Memory Limit: 65768/65768 K (Java/Others) Total Submission(s): 1626 Accepted Submission(s): 608 Special JudgeProblem Description When wake up, lxhgww find himself in a huge maze. The maze consisted by N rooms and tunnels connecting these rooms. Each pair of rooms is connected by one and only one path. Initially, lxhgww is in room 1. Each room has a dangerous trap. When lxhgww step into a room, he has a possibility to be killed and restart from room 1. Every room also has a hidden exit. Each time lxhgww comes to a room, he has chance to find the exit and escape from this maze. Unfortunately, lxhgww has no idea about the structure of the whole maze. Therefore, he just chooses a tunnel randomly each time. When he is in a room, he has the same possibility to choose any tunnel connecting that room (including the tunnel he used to come to that room). What is the expect number of tunnels he go through before he find the exit? Input First line is an integer T (T ≤ 30), the number of test cases. At the beginning of each case is an integer N (2 ≤ N ≤ 10000), indicates the number of rooms in this case. Then N-1 pairs of integers X, Y (1 ≤ X, Y ≤ N, X ≠ Y) are given, indicate there is a tunnel between room X and room Y. Finally, N pairs of integers Ki and Ei (0 ≤ Ki, Ei ≤ 100, Ki + Ei ≤ 100, K1 = E1 = 0) are given, indicate the percent of the possibility of been killed and exit in the ith room. Output For each test case, output one line “Case k: ”. k is the case id, then the expect number of tunnels lxhgww go through before he exit. The answer with relative error less than 0.0001 will get accepted. If it is not possible to escape from the maze, output “impossible”. Sample Input 331 21 30 0100 00 10031 22 30 0100 00 10061 22 31 44 54 60 020 3040 3050 5070 1020 60 Sample Output Case 1: 2.000000Case 2: impossibleCase 3: 2.895522 |
http://www.cnblogs.com/kuangbin/archive/2012/10/03/2711108.html
牛人的博客思路
dp求期望的题。 题意: 有n个房间,由n-1条隧道连通起来,实际上就形成了一棵树, 从结点1出发,开始走,在每个结点i都有3种可能: 1.被杀死,回到结点1处(概率为ki) 2.找到出口,走出迷宫 (概率为ei) 3.和该点相连有m条边,随机走一条 求:走出迷宫所要走的边数的期望值。 设 E[i]表示在结点i处,要走出迷宫所要走的边数的期望。E[1]即为所求。 叶子结点: E[i] = ki*E[1] + ei*0 + (1-ki-ei)*(E[father[i]] + 1); = ki*E[1] + (1-ki-ei)*E[father[i]] + (1-ki-ei); 非叶子结点:(m为与结点相连的边数) E[i] = ki*E[1] + ei*0 + (1-ki-ei)/m*( E[father[i]]+1 + ∑( E[child[i]]+1 ) ); = ki*E[1] + (1-ki-ei)/m*E[father[i]] + (1-ki-ei)/m*∑(E[child[i]]) + (1-ki-ei); 设对每个结点:E[i] = Ai*E[1] + Bi*E[father[i]] + Ci; 对于非叶子结点i,设j为i的孩子结点,则 ∑(E[child[i]]) = ∑E[j] = ∑(Aj*E[1] + Bj*E[father[j]] + Cj) = ∑(Aj*E[1] + Bj*E[i] + Cj) 带入上面的式子得 (1 - (1-ki-ei)/m*∑Bj)*E[i] = (ki+(1-ki-ei)/m*∑Aj)*E[1] + (1-ki-ei)/m*E[father[i]] + (1-ki-ei) + (1-ki-ei)/m*∑Cj; 由此可得 Ai = (ki+(1-ki-ei)/m*∑Aj) / (1 - (1-ki-ei)/m*∑Bj); Bi = (1-ki-ei)/m / (1 - (1-ki-ei)/m*∑Bj); Ci = ( (1-ki-ei)+(1-ki-ei)/m*∑Cj ) / (1 - (1-ki-ei)/m*∑Bj); 对于叶子结点 Ai = ki; Bi = 1 - ki - ei; Ci = 1 - ki - ei; 从叶子结点开始,直到算出 A1,B1,C1; E[1] = A1*E[1] + B1*0 + C1; 所以 E[1] = C1 / (1 - A1); 若 A1趋近于1则无解...
#include<iostream>#include<cstdio>#include<cstring>using namespace std;int len,head[10005];double A,B,C;double k[10005],e[10005];struct node{ int now,next;}tree[20005];void add(int x,int y){ tree[len].now=y; tree[len].next=head[x]; head[x]=len++;}void dfs(int root,int p){ int i,son,m=0; double a=0,b=0,c=0,q; for(i=head[root];i!=-1;i=tree[i].next) { son=tree[i].now; if(son==p) { continue; } dfs(son,root); a+=A; b+=B; c+=C; m++; } if(p != -1)++m; q=(1-k[root]-e[root])/m; A=(k[root]+q*a)/(1-q*b); B=q/(1-q*b); C=(1-k[root]-e[root]+q*c)/(1-q*b);}int main(){ int t,n,a,b,j,i; int x,y; scanf("%d",&t); for(j=1;j<=t;j++) { len=0; memset(head,-1,sizeof(head)); memset(e,0,sizeof(e)); memset(k,0,sizeof(k)); scanf("%d",&n); for(i=1;i<n;i++) { scanf("%d%d",&a,&b); add(a,b); add(b,a); } for(i=1;i<=n;i++) { scanf("%d%d",&x,&y); // printf("x=%d,y=%d\n",x,y); k[i]=x/100.0; e[i]=y/100.0; // printf("k[i]=%lf,e[i]=%lf\n",k[i],e[i]); } dfs(1,-1); if(1-A<1e-9) printf("Case %d: impossible\n",j); else printf("Case %d: %lf\n",j,C/(1-A)); } return 0;}
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。